aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorKarel Zak <kzak@redhat.com>2016-10-03 11:59:25 +0200
committerKarel Zak <kzak@redhat.com>2016-10-03 12:06:55 +0200
commit8b641fd6a220fd76a6c25b100d1ba43c6052efe2 (patch)
tree2f64454989c74d470c16395bd46a9c44fb33e37d
parent88b60f0bdee6a4379d5579918eec919bec94089f (diff)
downloadutil-linux-8b641fd6a220fd76a6c25b100d1ba43c6052efe2.tar.gz
tests: add chrt vs. nice test
Signed-off-by: Karel Zak <kzak@redhat.com>
-rw-r--r--tests/expected/schedutils/chrt-non-root-batch-vs-nice3
-rwxr-xr-xtests/ts/schedutils/chrt-non-root61
2 files changed, 64 insertions, 0 deletions
diff --git a/tests/expected/schedutils/chrt-non-root-batch-vs-nice b/tests/expected/schedutils/chrt-non-root-batch-vs-nice
new file mode 100644
index 0000000000..06cf51aaae
--- /dev/null
+++ b/tests/expected/schedutils/chrt-non-root-batch-vs-nice
@@ -0,0 +1,3 @@
+<removed> (process ID) old priority 0, new priority 5
+SCHED_BATCH
+0
diff --git a/tests/ts/schedutils/chrt-non-root b/tests/ts/schedutils/chrt-non-root
new file mode 100755
index 0000000000..4efb6f84bd
--- /dev/null
+++ b/tests/ts/schedutils/chrt-non-root
@@ -0,0 +1,61 @@
+#!/bin/bash
+#
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="chrt-non-user"
+
+. $TS_TOPDIR/functions.sh
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_CHRT"
+
+# TODO: drone.io does not like FIFO and RR (container restriction?)
+TS_KNOWN_FAIL="yes"
+
+function do_chrt {
+ $TS_CMD_CHRT $* $TS_CMD_CHRT --pid 0 | sed 's/.* policy: //; s/.* priority: //' &>> $TS_OUTPUT
+}
+
+function skip_policy {
+ $TS_CMD_CHRT --max | grep $1 | grep 'priority' &> /dev/null
+ if [ $? == 1 ]; then
+ ts_skip_subtest "unsupported"
+ return 1
+ fi
+ return 0
+}
+
+function cleanup_output {
+ sed -i -e 's/pid [0-9]*/<removed>/' $TS_OUTPUT
+ sed -i -e 's/[0-9]* (process/<removed> (process/' $TS_OUTPUT
+}
+
+ts_init_subtest "batch-vs-nice"
+skip_policy SCHED_BATCH
+if [ $? == 0 ]; then
+ renice -n 5 -p $$ &>> $TS_OUTPUT
+ do_chrt --batch 0
+ cleanup_output
+ ts_finalize_subtest
+fi
+
+# failed -- let's report kernel limits
+#
+if [ $TS_NSUBFAILED -ne 0 ]; then
+ echo "Supported policies:"
+ $TS_CMD_CHRT --max
+fi
+
+ts_finalize